/*  matches.cpp
 * 	
 *	A small game.
 *
 */
 
#include <iostream>

using namespace std;

int main(int argc, char* argv[]){
	
	// Read number of matches for game
	int nb_matches = -1;
	cout << "Mit wie vielen Streichhölzern spielen wir?" << endl;
	cin >> nb_matches;
	// Ensure that nb_matches is positive
	while (nb_matches <= 0){
		cout << "Bitte eine positive Zahl eingeben." << endl;
		cin >> nb_matches;	
	}
	
	// Determine starting player
	bool turn_player;
	cout << "Darf ich anfangen? (0: ja, 1: nein)" << endl;
	cin >> turn_player;
	
	// Play until no matches are left
	while(nb_matches > 0){
		
		// Turn of (human) player
		if(turn_player){
			cout << endl << "Wie viele Hölzer nimmst du? 1 oder 2?" << endl;
			int choice_player;
			cin >> choice_player;
			// Ensure that player takes only 1 or 2 matches
			while( (choice_player != 1) && (choice_player != 2) ){
				cout << "1 oder 2 Hölzer?" << endl;
				cin >> choice_player;
			} 
			nb_matches -= choice_player;
			cout << "Dann sind jetzt noch " << nb_matches << " da." << endl;
			turn_player = false;
		}
		// Turn of computer
		else{
			// Try to leave a multiple of 3 matches
			int r = nb_matches % 3;
			switch( r ){
				case 0:
					nb_matches -= 1;
					cout << "Ich habe 1 Streichholz genommen, jetzt sind noch " 
					     << nb_matches << " Hölzer da." << endl;
					break;
				case 1:
					nb_matches -= 1;
					cout << "Ich habe 1 Streichholz genommen, jetzt sind noch " 
					     << nb_matches << " Hölzer da." << endl;
					break;
				case 2:
					nb_matches -= 2;
					cout << "Ich habe 2 Streichhölzer genommen, jetzt sind noch " 
					     << nb_matches << " Hölzer da." << endl;
					break;				
				default: break;
			}
			turn_player = true;
		}	
	}
	
	// Winner is the one who had the last turn
	if(turn_player){
		cout << endl << "Juhu, ich habe gewonnen. Nochmal?" << endl;
	}
	else{
		cout << endl << "Glückwunsch! Du hast gewonnen." << endl;
	}

	return 0;
}
