/*  mittel_b.cpp
 * 	
 *	Calculation of the mean value of the 
 *  first n integer values.
 *
 *  n is read in as command line
 *  parameter
 *
 */
#include <iostream>
#include <cstdlib> 

using namespace std;

double mittelwert(int anzahl){
	
	double summe = 0;
	for(int k = 1; k <= anzahl; k++){
		summe += k;	
	}
	
	return (double)summe/anzahl;
}


int main(int argc, char* argv[]){
	
	if(argc != 2){
		cerr << "Usage: " << argv[0] << " n " << endl;
		exit(1);	
	}
	
	int n = atoi(argv[1]);
    if(n <= 0){
        cerr << "Error: n should be positive" << endl;
        exit(1);
    }
	
	double mittel = mittelwert(n);
		
	cout << "Der Mittelwert aller naürlichen Zahlen von 1 bis " << n << " ist " 
	     << mittel << endl;
	
	return 0;
}